<?php
/*
 * $Id: batch_new.done.php,v 1.8 2005/01/31 20:09:24 fukami Exp $
 * 新規エントリー投稿
 *
 */

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/projectdata.class.php');
require_once('class/threadlistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');
require_once('mod/thread/blog/class/commentlistdata.class.php');
require_once('mod/thread/blog/class/blog_pagegenerator.class.php');
require_once('mod/thread/blog/class/blog_smarty.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

require_once('func/trackback.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
//	require('func/inc/vars_to_variable.inc.php');
	extract($vars);
	$project_cd = $prjdat['cd'];
	if(empty($startdatetime))
	{
			$startdatetime = date("YmdHis");
	}

	// check
	$er=FALSE;
	$ermes=null;
//	if($prj==""){
//		$ermes.="<li>";
//		$ermes.="プロジェクトコードが空白です";
//		$ermes.="</li>\n";
//		$er=TRUE;
//	}
	if($thread_id==""){
		$ermes.="<li>";
		$ermes.="スレッドＩＤが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if($title==""){
		$ermes.="<li>";
		$ermes.="タイトルが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if($comment==""){
		$ermes.="<li>";
		$ermes.="記事が空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($comment) > BLOG_COMMENT_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="記事が長すぎです(".BLOG_COMMENT_MAX_STRLEN." バイトまで)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($comment) < BLOG_COMMENT_MIN_STRLEN){
		$ermes.="<li>";
		$ermes.="記事が短かすぎです(".BLOG_COMMENT_MIN_STRLEN." バイト以上必要)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($name) > NAME_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="名前が長すぎです(".NAME_MAX_STRLEN." バイトまで)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($title) > BLOG_SUBJECT_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="サブジェクトが長すぎです";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($startdatetime) < 8){
		$ermes.="<li>";
		$ermes.="予定日時が短かすぎます";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($startdatetime) > 14){
		$ermes.="<li>";
		$ermes.="予定日時が長すぎます";
		$ermes.="</li>\n";
		$er=TRUE;
	}


	if(is_array($_FILES["imagefile"]))
	{
		if(!prj_file_ext_check($imagefile_ext))
		{
			$ermes.="<li>";
			$ermes.="使えない拡張子です";
			$ermes.="</li>\n";
			$er=TRUE;
		}
	}

	if($er){
		$ermes="入力内容をもう一度確認してください<p><ul>".$ermes;
		$ermes.="</ul></p>前の画面に戻ってやりなおしてください";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	// デフォルト値で埋める
	if(("o"!=$inputformat) and 
		("h"!=$inputformat) and
		("w"!=$inputformat)){
		$inputformat="x";
	}

	// 予定日時０埋め
	while(strlen($startdatetime)<14)
	{
		$startdatetime.="0";
	}
	// 予定日時の分解
	$startdatetime_yyyy = substr($startdatetime,0,4);
	$startdatetime_mm = substr($startdatetime,4,2);
	$startdatetime_dd = substr($startdatetime,6,2);
	$startdatetime_hour = substr($startdatetime,8,2);
	$startdatetime_min = substr($startdatetime,10,2);
	$startdatetime_sec = substr($startdatetime,12,2);

	$entry_uri = HTTP_HOME_DIR.$project_cd.'/archives/blog/'.$thread_id.'/'.
			$startdatetime_yyyy.'/'.$startdatetime_mm.'/'.$startdatetime_dd.'_'.
			$startdatetime_hour.$startdatetime_min.$startdatetime_sec.'.html';
	$entry_path = APATH_HOME_DIR.$project_cd.'/archives/blog/'.$thread_id.'/'.
			$startdatetime_yyyy.'/'.$startdatetime_mm.'/'.$startdatetime_dd.'_'.
			$startdatetime_hour.$startdatetime_min.$startdatetime_sec.'.html';


	// html特殊文字の処理
/*	if('x' == $inputformat)
	{
		$comment =& phtmlenc($comment);
	}
*/
	// 要約文の作成
	if(empty($summary))
	{
		$summary=strip_tags(mb_strcut($comment,0,DESCRIPTION_CUT_STRLEN,PUBLOG_INTERNAL_ENCODING)).'...';
	}
	$summary=cut_nrt($summary);
//	$summary = phtmlenc($summary);

	// 形式に合わせた記事本文の加工
	$comment=ereg_replace("[\t]","",$comment);
	if(("o"!=$inputformat)&&("h"!=$inputformat)&&("w"!=$inputformat)){
//		$comment=phtmlenc($comment);
	}
//	if(("h"==$inputformat)||("w"==$inputformat)){
//		$comment=ereg_replace("[\n\r]+",PUBLOG_BETA_BR,$comment);
//	}else{
//		$comment=nl2br($comment);
//		$comment=ereg_replace("[\n\r]","",$comment);
//	}
	// \r\n\t カット
//	$vars=cut_nrt($vars);

	// 処理前の内容を保存
	$comment_moto=$comment;	// メール用に元データを保存
	$title_moto=$title;
	$name_moto=$name;

/*	// 2ch スレッドへのリンクをキャッシュサーバーへ変更
	if("x"==$inputformat){	// 本文はテキストタイプの時のみ
		$comment =& churl2href($comment);
	}
	$link =& churl2href($link);
*/

	// タグ除去など
	$name=strip_tags($name);
//	$title=phtmlenc($title);
	$url=strip_tags($url);
	$email=strip_tags($email);

//	$name = check_name($name,$prj);
// $name は 生トリップキーがついた状態↓
	$name_list=sep_name_trip10($name);	// name, trip
//	$name_list['name'] = phtmlenc($name_list['name']);

	$now = now_w3c();
//	$entry_id = date("YmdHis");
	$entry_id = $startdatetime;
	$systpl->assign('entry_id',$entry_id);
	if($type == 'wiki' or $type == 'html' or $type == 'htrmlbr')
	{
		$format = 'text/html';
	}else{
		$format = 'text/plain';
	}

	$url_this_entry = BlogPageGenerator::gen_entry_filename($thread_id,$entry_id,HTTP_HOME_DIR.$prjdat['cd'].'/archives/blog/');

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $project_cd
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'comment' => array(
					'id' => null
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);
	// エントリーファイルの生成
	$ini_entry = array(
		'entry' => array(
			'id' => $entry_id,
			'uri' => $entry_uri,
			'parent' => array(
				'id' => $thread_id
			),
			'title' => $title,
			'link' => $link,
			'input_format' => $inputformat,
			'type' => 'text',
			'format' => $format,
			'language' => LANG,
			'content' => $comment,
			'summary' => $summary,
			'issued' => $now,
			'modified' => $now,
			'author' => array(
				'name' => $name_list['name'],
				'trip' => $name_list['trip']
			),
			'subject' => null,
			'virtualdirectory' => $virtualdirectory,
			'publisher' => null,
			'rights' => null,
			'image' => array(
				'uri' => $image['uri'],
				'md5' => $image['md5'],
				'width' => $image_width,
				'height' => $image_height
			),
			'radio' => array(
				'uri' => $radio['uri'],
				'md5' => $radio['md5']
			),
			'flash' => array(
				'uri' => $flash['uri'],
				'md5' => $flash['md5'],
				'width' => $flash_width,
				'height' => $flash_height
			),
			'note' => $note
		)
	);
	$entry =& $blogdata->create('entry');
	$entry->new_xml_file($ini_entry);


	// コメントファイルの生成
	$ini_commentlist = array(
		'commentlist' => array(
			'id' => $startdatetime,
			'parent' => array(
				'id' => $startdatetime
			),
			'count' => '0'
		)
	);

	$commentlist =& $blogdata->create('commentlist');
	$commentlist->new_xml_file($ini_commentlist);

	// エントリーリストの生成
	$ini_entrylist = array(
		'id' => $entry_id,
		'title' => $title,
		'summary' => $summary,
		'issued' => $now,
		'modified' => $now,
		'author' => array(
				'name' => $name_list['name'],
				'trip' => $name_list['trip']
			)
	);
	if(!($entrylist =& $blogdata->load('entrylist')))
	{
		die ("EntrylistData Load Error(".$entrylist->conf['xml_file']['full_path'].")");
	}
	$entrylist->add($ini_entrylist);
	$entrylist->_save();


	// スレッドリストファイルの更新とage

	if(!($threadlist =& $blogdata->load('threadlist')))
	{
		die ("ThreadlistData Load Error(".$threadlist->conf['xml_file']['full_path'].")");
	}
	$threadlist->age($thread_id);



	// ページ更新
	blog_thread_all_rebuild($project_cd,$thread_id,$base_id=null,$lang_id=null);

	$systpl->assign('thread_id',$thread_id);

	$thread =& $blogdata->load('thread');
	if($thread)
	{
		$thread_data =& $thread->get_data();
	}
	$Thread = array(
		'id' => $thread_id,
		'title' => $thread_data['thread']['title']
	);

	// trackback
	$tbdata = array(
		'title'     => $title, // タイトル
		'url'       => $url_this_entry, // 送信時に再度、rawurlencode される
		'excerpt'   => $summary,
		'blog_name' => $Thread['title'],
		'charset'   => PUBLOG_INTERNAL_ENCODING, // 送信側文字コード(未既定)
		'author'   => $name_list['name'], // 執筆者:拡張
		'virtualdirectory'   => $virtualdirectory // バーチャルディレクトリ:拡張
	);
	tb_send($tbdata,$comment);


	$systpl->assign('http_archive_dir',HTTP_HOME_DIR.$project_cd.'/archives/');

        $systpl->assign('http_archive_dir',HTTP_HOME_DIR.$project_cd.'/archives/');

	// メール設定ファイル読み込み(mail.ini)
	$mail_ini_file = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail.ini';
	if(file_exists($mail_ini_file))
	{
		$mail_ini = parse_ini_file($mail_ini_file,true);
	}
	// エントリーメール発射
	if(!empty($mail_ini) and !empty($mail_ini['mail']['from'])){
		// HTML メール
		$mail_body_path_html = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mailbody_'.$thread_id.'_'.$entry_id.'_html.txt';
		$mail_list_path_html = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail_list_html.txt';
		$mail_from = $mail_ini['mail']['from'];
		$mail_subject = '['.$project_cd.'] '.$title;
		if(file_exists($mail_list_path_html))
		{
			entry_mail_set_html($mail_from,$mail_subject,
				$entry_path,$entry_uri,$prjdat['homeurl'],$mail_body_path_html);
			if(file_exists($mail_body_path_html))
			{
				entry_mail_kick($mail_from,$mail_list_path_html,$mail_body_path_html);
			}
		}
		// TEXT メール
		$mail_body_path_text = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mailbody_'.$thread_id.'_'.$entry_id.'_text.txt';
		$mail_list_path_text = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail_list_text.txt';
		$mail_from = $mail_ini['mail']['from'];
		$mail_subject = '['.$project_cd.'] '.$title;
		if(file_exists($mail_list_path_text))
		{
			entry_mail_set_text($mail_from,$mail_subject,
				$comment,$entry_uri,$prjdat['homeurl'],$mail_body_path_text);
			if(file_exists($mail_body_path_text))
			{
				entry_mail_kick($mail_from,$mail_list_path_text,$mail_body_path_text);
			}
		}
	}
	$systpl->assign('mailmagazine_kick',$mailmagazine_kick);

	// カテゴリping
	if(TRACKBACK_CATEGORY_NODE_SERVER and !empty($virtualdirectory)){
		// auto-trackback(カテゴリ)
		$cat_data=load_blog_cat_list();	// ブログカテゴリテーブルを読み込む
		$cat_tb_uri=$cat_data[$virtualdirectory][2];
		$result = http_request($cat_tb_uri,'POST','',$tbdata);
	}

	// バーチャルディレクトリー
	if(VIRTUALDIRECTORY_RCV_URI and !empty($virtualdirectory))
	{
		$log_uri = null;
		// スレッドロゴ
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo.gif')){
			$logo_uri=HTTP_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo.gif';
		}else
		// プロジェクトロゴ
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/logo.gif')){
			$logo_uri=HTTP_HOME_DIR.$project_cd.'/media/logo.gif';
		}
		$logomini_uri = null;
		// スレッドロゴ(mini)
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo_mini.gif')){
			$logomini_uri=HTTP_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo_mini.gif';
		}else
		// プロジェクトロゴ(mini)
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/logo_mini.gif')){
			$logomini_uri=HTTP_HOME_DIR.$project_cd.'/media/logo_mini.gif';
		}
		$vd_senddata = array(
			'title'     => $title, // タイトル
			'url'       => $url_this_entry, // 送信時に再度、rawurlencode される
			'excerpt'   => $summary,
			'blog_name' => $Thread['title'],
			'charset'   => PUBLOG_INTERNAL_ENCODING, // 送信側文字コード(未既定)
			'author'   => $name_list['name'], // 執筆者:拡張
			'vd'   => $virtualdirectory, // バーチャルディレクトリ:拡張
			'logo' => $logo_uri,
			'logo_mini' => $logomini_uri,
			'blog_url' => 'http://'.$prjdat['homeurl']
		);
		$result = http_request(VIRTUALDIRECTORY_RCV_URI,'POST','',$vd_senddata);

	}

return;



}
?>
