<?php
// $Id: comment.done.php,v 1.10 2004/10/06 15:51:45 fukami Exp $
// コメント入力
require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/projectdata.class.php');
require_once('class/threadlistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');
require_once('mod/thread/blog/class/commentlistdata.class.php');
require_once('mod/thread/blog/class/blog_pagegenerator.class.php');
require_once('mod/thread/blog/class/blog_smarty.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

require_once('func/trackback.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	require('func/inc/vars_to_variable.inc.php');

	// check
	$er=FALSE;
	$ermes=null;
	if(empty($comment_content))
	{
		$ermes.="<li>";
		$ermes.="コメントが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	$comment_content = mb_convert_encoding($comment_content,'UTF-8','auto');
	
	$entry_file = APATH_HOME_DIR.$project_cd.'/data/blog/'.
		$thread_id.'/'.
		substr($entry_id,0,4).'/'.
		substr($entry_id,4,2).'/entry_'.
		substr($entry_id,6,2).'_'.
		substr($entry_id,-6).'.xml';
	if(!file_exists($entry_file) or !is_writeable($entry_file))
	{
		$ermes.="<li>";
		$ermes.="コメントを送る対象のエントリーが存在しません";
		$ermes.="</li>\n";
		$er=TRUE;
	}

	if($er){
		$ermes="入力内容をもう一度確認してください<p><ul>".$ermes;
		$ermes.="</ul></p>前の画面に戻ってやりなおしてください";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	if(empty($comment_author_name))
	{
		$comment_author_name = '名無しさん';
	}
	
	$comment_content = htmlspecialchars($comment_content);
	$comment_author_name = htmlspecialchars($comment_author_name);
	$comment_title = htmlspecialchars($comment_title);
	$comment_link = htmlspecialchars($comment_link);
	$comment_author_email = htmlspecialchars($comment_author_email);
	$comment_publisher = htmlspecialchars($comment_publisher);
	
	$entry_id_yyyy = substr($entry_id,0,4);
	$entry_id_mm = substr($entry_id,4,2);

	$name_list=sep_name_trip10($comment_author_name);	// name, trip
	$now = now_w3c();

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $project_cd
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);
/*
	$conf_commentlist = array(
		'xml_file' => array(
			'full_path' =>  APATH_HOME_DIR.$project_cd.'/sys/data/thread/'.$thread_id.'/'.$entry_id_yyyy.'/'.$entry_id_mm.'/commentlist_'.$entry_id.'.xml'
		)
	);
*/
	$add_comment = array(
//			'comment' => array(
				'id' => null,
				'title' => $comment_title,
				'link' => $comment_link,
				'type' => 'text',
				'format' => 'text/plain',
				'language' => LANG,
				'author' => array(
					'name' => $name_list['name'],
					'trip' => $name_list['trip'],
					'email' => $comment_author_email
				),
				'content' => nl2br($comment_content),
				'issued' => $now,
				'modified' => $now,
				'publisher' => $comment_publisher
//			)
	);

	$commentlist =& $blogdata->load('commentlist');
	$list_count = $commentlist->add($add_comment);
	$commentlist->_save();

	$entry_link = HTTP_HOME_DIR.$project_cd.'/archives/blog/'.
		$thread_id.'/'.
		substr($entry_id,0,4).'/'.
		substr($entry_id,4,2).'/'.
		substr($entry_id,6,2).'_'.
		substr($entry_id,-6).'.html';

	// Entry
	$entry =& $blogdata->load('entry');
	if($entry)
	{
		$entry_data =& $entry->get();
	}else{
		die("Entry data load error");
	}
	$systpl->assign_by_ref('Entry',$entry_data);

	recently_writeback_add($project_cd,$thread_id,$entry_id,$entry_link,$list_count,$comment_title,$name_list,$now,$entry_data);

	// ページ更新
//	blog_thread_all_rebuild($project_cd,$thread_id,PUBLOG_SERVER_NAME,LANG);
	blog_thread_all_rebuild($project_cd,$thread_id,$base_id=null,$lang_id=null);

	$systpl->assign('entry_link',$entry_link);

	$retvars['body_as_main']=true;
	return;
}
?>
