<?php
// エントリー一覧の表示
require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

function do_mod_proc_disp()
{
	global $vars;
	global $smes,$pmes;
	global $prjdat,$userdat;
	global $systpl;
	require('func/inc/vars_to_variable.inc.php');


	// Core
	$Core = array(
		'id' => LANG
	);
	$systpl->assign_by_ref('Core',$Core);

	// Base
	$Base = array(
		'cd' => PUBLOG_SERVER_NAME
	);
	$systpl->assign_by_ref('Base',$Base);

	// Project
	$Project = array(
		'cd' => $prjdat['cd'],
		'title' => $prjdat['name']
	);
	$systpl->assign_by_ref('Project',$Project);


	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $thread_id
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);


	// Thread
	$thread =& $blogdata->create('thread');
	if($thread->load())
	{
		$thread_data =& $thread->get();
	}else{
		die("thread data load error.");
	}
	$systpl->assign_by_ref('Thread',$thread_data);

	// Entrylist
	$entrylist =& $blogdata->create('entrylist');
	if($entrylist->load())
	{
		$entrylist_data =& $entrylist->entrylist_all();
	}else{
		die("entrylist load error.");
	}
	$systpl->assign('Entrylist',$entrylist_data);

	return;
}
?>
