<?php
// $Id: rm_mediafile.done.php,v 1.1 2004/08/05 06:31:45 fukami Exp $
// メディアファイル削除

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	extract($vars);

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'comment' => array(
					'id' => null
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);

	$cat_data =& load_blog_cat_list();
	$VirtualDirectory = array();
	foreach($cat_data as $key => $val)
	{
		$VirtualDirectory[$key]=$val[1];
	}
	$systpl->assign_by_ref('VirtualDirectory',$VirtualDirectory);
	
	// Core
	$Core = array(
		'id' => LANG
	);
	$systpl->assign_by_ref('Core',$Core);

	// Base
	$Base = array(
		'cd' => PUBLOG_SERVER_NAME
	);
	$systpl->assign_by_ref('Base',$Base);

	// Project
	$Project = array(
		'cd' => $prjdat['cd'],
		'title' => $prjdat['name']
	);
	$systpl->passign_by_ref('Project',$Project);

	// Thread
	$thread =& $blogdata->load('thread');
	if($thread)
	{
		$thread_data =& $thread->get();
	}else{
		die("Thread data load error");
	}
	$systpl->passign_by_ref('Thread',$thread_data);

	// Entry
	$entry =& $blogdata->load('entry');
	if($thread)
	{
		$entry_data =& $entry->get();
	}else{
		die("Entry data load error");
	}
	$systpl->passign_by_ref('Entry',$entry_data);

	// media_type
	$systpl->passign_by_ref('media_type',$media_type);


	entry_rm_mediafile($media_type,$prjdat['cd'],$thread_id,$entry_id);
	$entry_data[$media_type] = null;
	unset($entry_data[$media_type]);
	$entry->_save();

	return;
}
?>
