<?php
// $Id: upd_mediafile.done.php,v 1.2 2005/01/31 20:08:54 fukami Exp $
// メディアファイル更新

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	global $ext;
	extract($vars);

	// check
	$er=FALSE;
	$ermes=null;
	if(!is_array($_FILES["imagefile"]) and
		!is_array($_FILES["radiofile"]) and
		!is_array($_FILES["flashfile"]))
	{
			$ermes.="<li>";
			$ermes.="ファイルがアップロードされていません";
			$ermes.="</li>\n";
			$er=TRUE;
	}
	
	if(is_array($_FILES["imagefile"]))
	{
		if(!prj_file_ext_check($imagefile_ext))
		{
			$ermes.="<li>";
			$ermes.="使えない拡張子です";
			$ermes.="</li>\n";
			$er=TRUE;
		}
	}
	if($er){
		$ermes="入力内容をもう一度確認してください<p><ul>".$ermes;
		$ermes.="</ul></p>前の画面に戻ってやりなおしてください";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	// ファイルアップロード
	if(is_array($_FILES["imagefile"]))
	{
		$image =& entry_upload('image',$imagefile_ext,$_FILES["imagefile"],
			$prjdat['cd'],$thread_id,$entry_id);
	}
	if(is_array($_FILES["radiofile"]))
	{
		$radio =& entry_upload('radio','.mp3',$_FILES["radiofile"],
			$prjdat['cd'],$thread_id,$entry_id);
	}
	if(is_array($_FILES["flashfile"]))
	{
		$flash =& entry_upload('flash','.swf',$_FILES["flashfile"],
			$prjdat['cd'],$thread_id,$entry_id);
	}

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'comment' => array(
					'id' => null
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);

	$cat_data =& load_blog_cat_list();
	$VirtualDirectory = array();
	foreach($cat_data as $key => $val)
	{
		$VirtualDirectory[$key]=$val[1];
	}
	$systpl->assign_by_ref('VirtualDirectory',$VirtualDirectory);
	
	// Core
	$Core = array(
		'id' => LANG
	);
	$systpl->assign_by_ref('Core',$Core);

	// Base
	$Base = array(
		'cd' => PUBLOG_SERVER_NAME
	);
	$systpl->assign_by_ref('Base',$Base);

	// Project
	$Project = array(
		'cd' => $prjdat['cd'],
		'title' => $prjdat['name']
	);
	$systpl->passign_by_ref('Project',$Project);

	// Thread
	$thread =& $blogdata->load('thread');
	if($thread)
	{
		$thread_data =& $thread->get();
	}else{
		die("Thread data load error");
	}
	$systpl->passign_by_ref('Thread',$thread_data);

	// Entry
	$entry =& $blogdata->load('entry');
	if(is_array($image) and !empty($image['uri']))
	{
		$entry->pxml->node_data['entry']['image']['uri'] = $image['uri'];
		$entry->pxml->node_data['entry']['image']['md5'] = $image['md5'];
		if(!empty($image_width))
			$entry->pxml->node_data['entry']['image']['width'] = $image_width;
		if(!empty($image_height))
			$entry->pxml->node_data['entry']['image']['height'] = $image_height;
		$entry->_save();
	}
	if(is_array($radio) and !empty($radio['uri']))
	{
		$entry->pxml->node_data['entry']['radio']['uri'] = $radio['uri'];
		$entry->pxml->node_data['entry']['radio']['md5'] = $radio['md5'];
/*		$ini_entry = array(
			'entry' => array(
				'radio' => array(
					'uri' => $radio['uri'],
					'md5' => $radio['md5']
				),
			)
		);
		$entry->merge($ini_entry);
*/
		$entry->_save();
	}
	if(is_array($flash) and !empty($flash['uri']))
	{
		$entry->pxml->node_data['entry']['flash']['uri'] = $flash['uri'];
		$entry->pxml->node_data['entry']['flash']['md5'] = $flash['md5'];
		if(!empty($flash_width))
			$entry->pxml->node_data['entry']['flash']['width'] = $flash_width;
		if(!empty($flash_height))
			$entry->pxml->node_data['entry']['flash']['height'] = $flash_height;
		$entry->_save();
	}
	if($thread)
	{
		$entry_data =& $entry->get();
	}else{
		die("Thread data load error");
	}
	$systpl->passign_by_ref('Entry',$entry_data);

	// media_type
	$systpl->passign_by_ref('media_type',$media_type);

	$systpl->assign('http_archive_dir',HTTP_HOME_DIR.$prjdat['cd'].'/archives/');
	$systpl->assign('project_cd',$prjdat['cd']);
	$systpl->assign('thread_id',$thread_id);
	$systpl->assign('entry_id',$entry_id);

	return;
}
?>
