<?php
// デザイン関連

// デザインファイルインポート
function &design_import($src_dir,$dest_dir)
{
	// http: しか通さない
	if(substr($src_dir,0,7) != 'http://'){
		return false;
	}
	$filename = $src_dir.'filelist.txt';
	$fp = fopen($filename, "r");
	if(!$fp) {
		return false;
	}
	$list=array();
	while(!feof($fp)) {
		$arr=fgetcsv($fp,20000,"\t");
		if(!is_array($arr)) continue;
		$list[]=$arr;
	}
	fclose($fp);
//	$list =& load_file_table($src_dir.'filelist.txt');
	if(!is_array($list))
	{
		return false;
	}

	design_copy($src_dir,$dest_dir,$list);
	return $list;
}
// デザインディレクトリコピー(リモート対応)
function design_copy($src_dir,$dest_dir,&$list)
{
	global $ext;	// 拡張子リスト
	$erflg = true;
	foreach($list as $key => $var)
	{
		$ret = true;
		$parsed_url = publog_parse_url($var[1]);
		if(!array_search('.'.$parsed_url['extension'],$ext['upload'])){
			continue;
		}
		if($var[0]=='file'){
				$ret = copy($src_dir.$var[1],$dest_dir.$var[1]);
				chmod($dest_dir.$var[1],0707);
		}elseif($var[0]=='remote'){
				$ret = copy($var[1],$dest_dir.$parsed_url['basename']);
				chmod($dest_dir.$parsed_url['basename'],0707);
		}else{
			continue;
		}
		if($ret)
		{
			$list[$key]['ret'] = 'success';
		}else{
			$list[$key]['ret'] = 'error';
			$erflg = false;
			continue;
		}
	}
	// filelist.txt 本体
	$ret = copy($src_dir.'filelist.txt',$dest_dir.'filelist.txt');
	chmod($dest_dir.'filelist.txt',0707);
	if(!$ret)
	{
		$erflg = false;
	}
	return $erflg;
}


?>
