<?php
// $Id: vd.func.php,v 1.27 2004/12/15 20:06:08 fukami Exp $
// vd.func.php

function &vd_disp_file($filename,$last=10,$type="box",$css="")
{
	if(file_exists($filename))
		$data = file_get_contents($filename);
	else
		return false;
	
	$ret = null;
	$disp_func = 'vd_disp_'.$type;
	$ret =& $disp_func($data,$last,$css);
	return $ret;
}

function &vd_disp_box($data,$last=10,$css="",$title="")
{

	$o = explode("\n",$data);
	$o = array_reverse($o);
	$out=null;
	$out.="<div class=\"vd_list\">\n";
	$loopcount=0;
	foreach($o as $line)
	{
	$l = explode("\t",$line);
	if(""==trim($l[3]))
		continue;
	if(!empty($l[8]))
	{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\"><img src=\"".$l[8]."\" border=\"0\" alt=\"".$l[2]."\" width=\"148\" height=\"37\" /><br />".$l[2]."</a>";
	}else{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\">".$l[2]."</a>";
	}

	if(!empty($l[9]))
	{
		$blog_link="<a href=\"".$l[9]."\" target=\"_top\">".$l[5]."</a>";
	}else{
		$blog_link=$l[5];
	}

$out .= <<<EOD
<div class="vd">
	<div class="vd_head">
	$headlink
	</div>
	<div class="vd_body">
	$l[4]
		<span class="vd_author">
		($l[7]) 
		</span>
	</div>
	<div class="vd_foot">
		<!-- class="vd_datetime"
		$l[0]
		-->
		<div class="vd_blog_name">
		$blog_link
		</div>
	</div>
</div>
EOD;
	$loopcount++;
	if($loopcount >= $last)
		break;
	}

	$out.="</div>";

if($css == "")
	$vd_css = HTTP_ROOT.'vd.css';
else
	$vd_css = $css;

$head = <<<EOD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" type="text/css" href="$vd_css">
<body>
<div class="universe">
EOD;

$foot = <<<EOD
</div>
</body>
</html>
EOD;

/*print($head);
print($out);
print($foot);
*/

	return $head.$out.$foot;

}

// ミニ表示
function &vd_disp_mini($data,$last=10,$css="",$title="")
{

	$o = explode("\n",$data);
	$o = array_reverse($o);
	$out=null;
	$out.="<div class=\"vd_list\">\n";
	$loopcount=0;
	foreach($o as $line)
	{
	$l = explode("\t",$line);
	if(""==trim($l[3]))
		continue;
	if(!empty($l[10]))
	{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\"><img src=\"".$l[10]."\" border=\"0\" alt=\"".$l[2]."\" width=\"80\" height=\"15\" /> ".$l[2]."</a>";
	}else{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\">".$l[2]."</a>";
	}

	if(!empty($l[9]))
	{
		$blog_link="<a href=\"".$l[9]."\" target=\"_top\">".$l[5]."</a>";
	}else{
		$blog_link=$l[5];
	}
	$datetime = substr($l[0],0,10).' '.substr($l[0],11,8);
$out .= <<<EOD
<div class="vd">
<div class="vd_top">
	<div class="vd_head">
	$headlink
	</div>
	<div class="vd_foot">
		<div class="vd_datetime">
		[$datetime]
		</div>
		<div class="vd_blog_name">
		$blog_link
		</div>
	</div>
</div>
	<div class="vd_body">
	$l[4]
		<span class="vd_author">
		($l[7]) 
		</span>
	</div>
</div>
EOD;
	$loopcount++;
	if($loopcount >= $last)
		break;
	}

	$out.="</div>";

if($css == "")
	$vd_css = HTTP_ROOT.'vd_mini.css';
else
	$vd_css = $css;

$head = <<<EOD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" type="text/css" href="$vd_css">
<body>
<div class="universe">
EOD;

$foot = <<<EOD
</div>
</body>
</html>
EOD;

/*print($head);
print($out);
print($foot);
*/

	return $head.$out.$foot;

}

// re表示
function &vd_disp_re($data,$last=10,$css="",$title="")
{

	$o = explode("\n",$data);
	$o = array_reverse($o);
	$out=null;
	$out.="<div class=\"vd_list\">\n";
	$loopcount=0;
	foreach($o as $line)
	{
	$l = explode("\t",$line);
	if(""==trim($l[3]))
		continue;
	if(!empty($l[10]))
	{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\"><img src=\"".$l[10]."\" border=\"0\" alt=\"".$l[2]."\" width=\"80\" height=\"15\" /> ".$l[2]."</a>";
	}else{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\">".$l[2]."</a>";
	}

	if(!empty($l[9]))
	{
		$blog_link="<a href=\"".$l[9]."\" target=\"_top\">".$l[5]."</a>";
	}else{
		$blog_link=$l[5];
	}
	$datetime = substr($l[0],0,10).' '.substr($l[0],11,8);
$out .= <<<EOD
<div class="re">
	<div class="re_head">
		<div class="re_title">$headlink</div>
		<div class="re_date">$blog_link / [$datetime]</div>
	</div>
	<div class="re_body">$l[4] ($l[7]) </div>
</div>
EOD;
	$loopcount++;
	if($loopcount >= $last)
		break;
	}

	$out.="</div>";

if($css == "")
	$vd_css = HTTP_ROOT.'vd_re.css';
else
	$vd_css = $css;

$head = <<<EOD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" type="text/css" href="$vd_css">
<body>
<div class="title">
$title
</div>
<div class="universe">
EOD;

$foot = <<<EOD
</div>
</body>
</html>
EOD;

/*print($head);
print($out);
print($foot);
*/

	return $head.$out.$foot;

}



// 削除表示
function &vd_disp_del($data,$last=10,$css="")
{
	global $vars;
	$vd=$vars['vd'];

	$o = explode("\n",$data);
	$o = array_reverse($o);
	$out=null;
	$out.="<div class=\"vd_list\">\n";
	$loopcount=0;
	foreach($o as $line)
	{
	$l = explode("\t",$line);
	if(""==trim($l[3]))
		continue;
	if(!empty($l[10]))
	{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\"><img src=\"".$l[10]."\" border=\"0\" alt=\"".$l[2]."\" width=\"80\" height=\"15\" /> ".$l[2]."</a>";
	}else{
		$headlink="<a href=\"".$l[3]."\" target=\"_top\">".$l[2]."</a>";
	}

	if(!empty($l[9]))
	{
		$blog_link="<a href=\"".$l[9]."\" target=\"_top\">".$l[5]."</a>";
	}else{
		$blog_link=$l[5];
	}
	$datetime = substr($l[0],0,10).' '.substr($l[0],11,8);
	$delid = rawurlencode($l[0].$l[3]);
	$dellink = "<a href=\"publog.php?lv=core&mod=vd&cmd=del&trans=done&vd=".$vd."&delid=".$delid."\" target=\"_top\">[delete]</a>";
$out .= <<<EOD
<div class="vd">
<div class="vd_top">
	<div class="vd_head">
	$dellink
	$headlink
	</div>
	<div class="vd_foot">
		<div class="vd_datetime">
		[$datetime]
		</div>
		<div class="vd_blog_name">
		$blog_link
		</div>
	</div>
</div>
	<div class="vd_body">
	$l[4]
		<span class="vd_author">
		($l[7]) 
		</span>
	</div>
</div>
EOD;
	$loopcount++;
	if($loopcount >= $last)
		break;
	}

	$out.="</div>";

if($css == "")
	$vd_css = HTTP_ROOT.'vd_mini.css';
else
	$vd_css = $css;

$head = <<<EOD
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" type="text/css" href="$vd_css">
<body>
<p>
カテゴリ: $vd <br />
[delete]クリックで削除。確認画面はありません。いきなり削除です。 <br />
<form action="publog.php?lv=core&mod=vd&cmd=del&trans=start" method="post">
<input type="text" value="$vd" name="vd">
<input type="submit" value="カテゴリ変更">
</form>
</p>
<div class="universe">
EOD;

$foot = <<<EOD
</div>
</body>
</html>
EOD;

/*print($head);
print($out);
print($foot);
*/

	return $head.$out.$foot;

}


/*
// sample
		// スレッドロゴ
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo.gif')){
			$logo_uri=HTTP_HOME_DIR.$project_cd.'/media/blog/'.$thread_id.'/logo.gif';
		}else
		// プロジェクトロゴ
		if(file_exists(APATH_HOME_DIR.$project_cd.'/media/logo.gif')){
			$logo_uri=HTTP_HOME_DIR.$project_cd.'/media/logo.gif';
		}
		$vd_senddata = array(
		'title'     => $title, // タイトル
		'url'       => $url_this_entry, // 送信時に再度、rawurlencode される
		'excerpt'   => $summary,
		'blog_name' => $Thread['title'],
		'charset'   => PUBLOG_INTERNAL_ENCODING, // 送信側文字コード(未既定)
		'author'   => $name_list['name'], // 執筆者:拡張
		'vd'   => $virtualdirectory // バーチャルディレクトリ:拡張
	);
	$result = http_request($vd_rcv_uri,'POST','',$vd_senddata);

*/

?>
