<?php
// $Id: blog_rebuild.php,v 1.2 2004/12/13 02:41:23 fukami Exp $
// 第1引数：実行ディレクトリ
// 第2引数：プロジェクトコード
// 第3引数：スレッドID

	$exec_dir = trim($argv[1]);
	$project_cd = trim($argv[2]);
	$thread_id = trim($argv[3]);

	if(!is_dir($exec_dir))
		exit;

	chdir($exec_dir);

	// ユーザー設定ファイル
	$conf=parse_ini_file('publog_conf.ini',TRUE);
	// 設定ファイル def 系
	require_once("publog_def.ini");
// Smartyライブラリを読み込む
if(!file_exists(SMARTY_CLASS_FILE))
{
	require_once('Smarty.class.php');
}else{
	require_once(SMARTY_CLASS_FILE);
}
require_once("class/smarty.class.php");

// PUBLOG システム関数
require_once("func/mod.func.php");
require_once("func/error.func.php");
require_once("func/login.func.php");
require_once("func/project.func.php");
require_once("func/staff.func.php");
require_once("func/trip.func.php");
require_once("func/file.func.php");
require_once("func/html.func.php");
require_once("func/std.func.php");
require_once("func/publog.func.php");
require_once("func/ini.func.php");
require_once("func/base.func.php");

//---
require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/projectdata.class.php');
require_once('class/threadlistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');
require_once('mod/thread/blog/class/commentlistdata.class.php');
require_once('mod/thread/blog/class/blog_pagegenerator.class.php');
require_once('mod/thread/blog/class/blog_smarty.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

require_once('func/trackback.func.php');

	// ページ更新
	if(!blog_thread_all_rebuild_do($project_cd,$thread_id,
		$base_id=null,$lang_id=null))
	{
		$ermes="<p>再構築に失敗しました</p>";
		$ermes="<p>考えられる原因</p>";
		$ermes.="<ul>";
		$ermes.="<li>エントリーがまだひとつもない</li>";
		$ermes.="<li>データ不整合</li>";
		$ermes.="</ul>";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	exit;
?>

