<?php
// $Id: send.done.php,v 1.7 2004/08/30 03:08:36 fukami Exp $
// メール送信

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/projectdata.class.php');

require_once('class/publogdata.class.php');


require_once('func/mail.func.php');

function do_mod_proc_disp()
{
	global $vars,$retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	extract($vars);

	// check
	$er=FALSE;
	$ermes=null;
	if(empty($project_cd)){
		$ermes.="<li>";
		$ermes.="プロジェクトコードが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
/*	if(empty($subject)){
		$ermes.="<li>";
		$ermes.="タイトルが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
*/
	if(empty($message)){
		$ermes.="<li>";
		$ermes.="メッセージが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if($er){
		$ermes="入力内容をもう一度確認してください<p><ul>".$ermes;
		$ermes.="</ul></p>前の画面に戻ってやりなおしてください";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	$list = stafflist_prj_get($project_cd);

	if(0 >= count($list))
	{
		$ermes="存在しないプロジェクトです";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}
	
	$staff_email = array();
	foreach($list as $staff)
	{
		$staff_email[] = $staff[3];
	}

	if(empty($subject))
	{
		$subject = "なし";
	}
	// メールのサブジェクト
	$mail_subject = '['.$project_cd.'] from PUBLOG('.PUBLOG_SERVER_NAME.') user';

	// データオブジェクト ====================
	$publogdata_conf = array(
				'project' => array(
					'cd' => $project_cd
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new PublogData($publogdata_conf);


	$project =& $blogdata->load('project');
	if($project)
	{
		$project_data =& $project->get_data();
	}else{
		die("Thread data load error");
	}
	// Project
	$Project = array(
		'cd' => $project_cd,
		'title' => $project_data['project']['title'],
		'link' => 'http://'.$project_data['project']['link'],
		'tagline' => $project_data['project']['tagline']
	);
	$systpl->assign_by_ref('Project',$Project);


	$body = "PUBLOG(".PUBLOG_SERVER_NAME.") 経由のメッセージです。\n";
	$body.= "プロジェクト[".$Project['title']."] に対して発信されました。\n";
	$body.= "\n";
	$body.= "サブジェクト: ".$subject."\n";
	$body.= "\n";
	$body.= "本文:\n";
	$body.= "\n";
	$body.= $message;
	$body.= "\n";

	$additional_headers=null;
	if(!empty($mail_from))
	{
		if(check_email($mail_from))
		{
			$additional_headers.="From: ".$mail_from."\n";
		}
	}

	$body = mb_convert_encoding($body,'JIS','auto');
	publog_snap_email_to_list($staff_email,$mail_subject,$body,$additional_headers);

	$retvars['main_tpl']='tool_main_nologin.tpl';

	return;
}
?>
