<?php
/*
 * $Id: rmthread.done.php,v 1.3 2004/07/28 17:09:20 fukami Exp $
 * スレッド削除
 */

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/threadlistdata.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

function do_mod_proc_disp()
{
	global $vars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	require_once('func/ita.func.php');
	require('func/inc/vars_to_variable.inc.php');

	if(""==$selected_threadid)
		error_exit("スレッドIDが空白です");
	if(""==$thread_type)
		error_exit("スレッドタイプが空白です");
	if(!ereg("^[a-z0-9]+", $selected_threadid))
		error_exit("無効なスレッドIDです");


	// データオブジェクト ====================
	$publogdata_conf = array(
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $selected_threadid,
					'type' => $thread_type
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$publogdata = new PublogData($publogdata_conf);

	if($threadlist =& $publogdata->load('threadlist'))
	{
		$removed_thread = $threadlist->remove($selected_threadid);
	}else{
		die ("Thread Remove Error (".$selected_threadid.")");
	}
	$threadlist->_save();


	// 関連データをどんどん削除
	// data
	$rm_data_dir = APATH_HOME_DIR.$prjdat['cd'].'/data/'.$thread_type.'/'.$selected_threadid;
	deldir($rm_data_dir);
	// archives
	$rm_archives_dir = APATH_HOME_DIR.$prjdat['cd'].'/archives/'.$thread_type.'/'.$selected_threadid;
	deldir($rm_archives_dir);
	// design
	$rm_design_dir = APATH_HOME_DIR.$prjdat['cd'].'/design/'.$thread_type.'/'.$selected_threadid;
	deldir($rm_design_dir);
	// feeds
//	$rm_feeds_dir = APATH_HOME_DIR.$prjdat['cd'].'/feeds/'.$thread_type.'/'.$selected_threadid;
//	deldir($rm_feeds_dir);
	// hidden_data
	$rm_hidden_dir = HIDDEN_DIR.$prjdat['cd'].'/thread/'.$thread_type.'/'.$selected_threadid;
	deldir($rm_hidden_dir);

	$rm_media_dir = HIDDEN_DIR.$prjdat['cd'].'/thread/'.$thread_type.'/'.$selected_threadid;
	deldir($rm_media_dir);


//	$deleted_thread=rm_thread($prjdat['cd'],$selected_threadid);

//	upd_itapage($prjdat['cd']);

//	create_subback($prjdat['cd']);
	
	$systpl->assign('Thread',$removed_thread);
}
?>
