<?php
// エントリーリストデータ共通処理クラス
class CommentlistData extends PUBLOGXMLListData
{
/*
	$comment_data = array(
		'id' => null,
		'title' => null,
		'link' => null,
		'tagline' => null,
		'message' => null,
		'issued' => null,
		'modified' => null
		'author' => array(
			'name' => null,
			'email' => null
		)
	);
*/
// コンストラクタ ----------------------------------
	function CommentlistData($conf = null)
	{
		$list_conf = array(
			'rt' => 'commentlist',	// root tag name
			'lt' => 'comment'		// list tag name
		);

		parent::PUBLOGXMLListData($conf,$list_conf);
	}
	function add($listdata)
	{
		if(empty($listdata['id']))
		{
			$ctr = $this->list_counter + 1;
			while($ctr < 2000)
			{
				if(!array_key_exists('comment__'.(string)$ctr, $this->pxml->node_data['commentlist']))
				{
					break;
				}
				$ctr++;
			}
			$listdata['id'] = (string)$ctr;
		}
		parent::add($listdata);
		return $listdata['id'];
	}
// テンプレートへ渡すデータの加工 ----------------------------------
	function &commentlist_all()
	{
		if(empty($this->pxml))
		{
			return false;
		}else{
			return $this->pxml->get_array('/commentlist/comment');
		}
	}

	function &commentlist_count($arr=array())
	{
		if(empty($arr['entry_id']))
		{
			return null;
		}
		$this->conf['entry']['id']=$arr['entry_id'];
		if(empty($this->pxml))
		{
			return false;
		}else{
			$com =& $this->pxml->get_array('/commentlist/comment');
			if(empty($com) or false == $com or null == $com or !is_array($com))
			{
				$ct = 0;
			}else{
				$ct = count($com);
			}
			return $ct;
		}
	}

}


?>
