<?php
// $Id: entrydata.class.php,v 1.8 2004/12/29 11:06:17 fukami Exp $

require_once('func/pukiwiki.func.php');

// ・新規エントリーの追加
// ・エントリーの修正
// ・エントリーの削除
class EntryData extends PublogXMLData
{

	function &get($options=array())
	{
		$entry =& $this->pxml->node_data['entry'];
		if($entry['input_format']=='x')
		{
			$entry =& array_phtmlenc_by_ref($entry);
			if($options['contents_nl2br'])
			{
				$entry['content'] = nl2br($entry['content']);
			}
		}elseif($entry['input_format']=='w'){
			if($options['contents_wiki'])
			{
				$entry['content'] =& pukiwiki_convert($entry['content']);
			}
		}else{
				$entry['summary'] =& phtmlenc_by_ref($entry['summary']);
				$entry['title'] =& phtmlenc_by_ref($entry['title']);
				$entry['author']['name'] =& phtmlenc_by_ref($entry['author']['name']);
		}
		$url_this_entry = HTTP_HOME_DIR.$this->conf['project']['cd'].'/archives/blog/'.
			$this->conf['thread']['id'].'/'.
			substr($this->conf['entry']['id'],0,4).'/'.
			substr($this->conf['entry']['id'],4,2).'/'.
			substr($this->conf['entry']['id'],6,2).'_'.
			substr($this->conf['entry']['id'],-6).'.html';
		$entry['url_this_entry'] = $url_this_entry;
		$trackback_url =HTTP_SCRIPT_DIR.PUBLOG_SCRIPT_FILE.'?lv=thread&mod=blog&cmd=tb&id='.$this->conf['project']['cd'].'/'.$this->conf['thread']['id'].'/'.$this->conf['entry']['id'];
		$entry['trackback_url'] = $trackback_url;
		$writeback_url =HTTP_SCRIPT_DIR.PUBLOG_SCRIPT_FILE.'?lv=thread&mod=blog&cmd=comment&trans=start&project_cd='.$this->conf['project']['cd'].'&thread_id='.$this->conf['thread']['id'].'&entry_id='.$this->conf['entry']['id'];
		$entry['writeback_url'] = htmlspecialchars($writeback_url);
		return $entry;
	}
}

?>
