<?php
/*
 * $Id: new.done.php,v 1.25 2004/12/10 23:16:39 fukami Exp $
 * 新規エントリー投稿
 *
 */

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/projectdata.class.php');
require_once('class/threadlistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');
require_once('mod/thread/blog/class/commentlistdata.class.php');
require_once('mod/thread/blog/class/blog_pagegenerator.class.php');
require_once('mod/thread/blog/class/blog_smarty.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

require_once('func/trackback.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
//	require('func/inc/vars_to_variable.inc.php');
	extract($vars);
	$project_cd = $prjdat['cd'];
	if(empty($startdatetime))
	{
			$startdatetime = date("YmdHis");
	}
	// 予約配信
	if('yes' == $reserve_yes)
	{
		$startdatetime = $ReserveDateYear.$ReserveDateMonth.$ReserveDateDay.$ReserveDateHour.$ReserveDateMinute.'00';
	}
	// check
	$er=FALSE;
	$ermes=null;
//	if($prj==""){
//		$ermes.="<li>";
//		$ermes.="プロジェクトコードが空白です";
//		$ermes.="</li>\n";
//		$er=TRUE;
//	}
	if($thread_id==""){
		$ermes.="<li>";
		$ermes.="スレッドＩＤが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if($title==""){
		$ermes.="<li>";
		$ermes.="タイトルが空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if($comment==""){
		$ermes.="<li>";
		$ermes.="記事が空白です";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($comment) > BLOG_COMMENT_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="記事が長すぎです(".BLOG_COMMENT_MAX_STRLEN." バイトまで)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($comment) < BLOG_COMMENT_MIN_STRLEN){
		$ermes.="<li>";
		$ermes.="記事が短かすぎです(".BLOG_COMMENT_MIN_STRLEN." バイト以上必要)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($name) > NAME_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="名前が長すぎです(".NAME_MAX_STRLEN." バイトまで)";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($title) > BLOG_SUBJECT_MAX_STRLEN){
		$ermes.="<li>";
		$ermes.="サブジェクトが長すぎです";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($startdatetime) < 8){
		$ermes.="<li>";
		$ermes.="予定日時が短かすぎます";
		$ermes.="</li>\n";
		$er=TRUE;
	}
	if(strlen($startdatetime) > 14){
		$ermes.="<li>";
		$ermes.="予定日時が長すぎます";
		$ermes.="</li>\n";
		$er=TRUE;
	}


	if(is_array($_FILES["imagefile"]))
	{
		if(!prj_file_ext_check($imagefile_ext))
		{
			$ermes.="<li>";
			$ermes.="使えない拡張子です";
			$ermes.="</li>\n";
			$er=TRUE;
		}
	}

	if($er){
		$ermes="入力内容をもう一度確認してください<p><ul>".$ermes;
		$ermes.="</ul></p>前の画面に戻ってやりなおしてください";
		$retvars['usetpl']=false;
		return error_out($ermes);
	}

	// デフォルト値で埋める
	if(("o"!=$inputformat) and 
		("h"!=$inputformat) and
		("w"!=$inputformat)){
		$inputformat="x";
	}

	// 予定日時０埋め
	while(strlen($startdatetime)<14)
	{
		$startdatetime.="0";
	}
	// 予定日時の分解
	$startdatetime_yyyy = substr($startdatetime,0,4);
	$startdatetime_mm = substr($startdatetime,4,2);
	$startdatetime_dd = substr($startdatetime,6,2);
	$startdatetime_hour = substr($startdatetime,8,2);
	$startdatetime_min = substr($startdatetime,10,2);
	$startdatetime_sec = substr($startdatetime,12,2);

	$entry_uri = HTTP_HOME_DIR.$project_cd.'/archives/blog/'.$thread_id.'/'.
			$startdatetime_yyyy.'/'.$startdatetime_mm.'/'.$startdatetime_dd.'_'.
			$startdatetime_hour.$startdatetime_min.$startdatetime_sec.'.html';
	$entry_path = APATH_HOME_DIR.$project_cd.'/archives/blog/'.$thread_id.'/'.
			$startdatetime_yyyy.'/'.$startdatetime_mm.'/'.$startdatetime_dd.'_'.
			$startdatetime_hour.$startdatetime_min.$startdatetime_sec.'.html';

	// クッキー書き込み
	header("Set-Cookie: FROM=".$name."; expires=Fri, 31-Dec-2030 23:59:59; path=/;");
	header("Set-Cookie: MAIL=".$email."; expires=Fri, 31-Dec-2030 23:59:59; path=/;");

	// ファイルアップロード
	if(is_array($_FILES["imagefile"]))
	{
		$image =& entry_upload('image',$imagefile_ext,$_FILES["imagefile"],
			$prjdat['cd'],$thread_id,$startdatetime);
	}
	if(is_array($_FILES["radiofile"]))
	{
		$radio =& entry_upload('radio','.mp3',$_FILES["radiofile"],
			$prjdat['cd'],$thread_id,$startdatetime);
	}
	if(is_array($_FILES["flashfile"]))
	{
		$flash =& entry_upload('flash','.swf',$_FILES["flashfile"],
			$prjdat['cd'],$thread_id,$startdatetime);
	}

	// 他サーバーからアップロード
	if(!empty($remote_imagefile))
	{
		$image =& entry_upload_remote('image',$imagefile_ext,$remote_imagefile,
					$prjdat['cd'],$thread_id,$startdatetime);
	}


	$vars_tmp = $vars;
	$vars_tmp['startdatetime'] = $startdatetime;
	if(!empty($image))
	{
		$vars_tmp['image'] = $image;
	}
	if(!empty($radio))
	{
		$vars_tmp['radio'] = $radio;
	}
	if(!empty($flash))
	{
		$vars_tmp['flash'] = $flash;
	}
	$vars_tmp['cmd'] = 'batch_new';
	$batch_out = null;
	$batch_out.= "<?php\n";
	$batch_out.= '$vars = '.var_export($vars_tmp,true).';';
	$batch_out.= "\n";
	$batch_out.= '$prjdat = '.var_export($prjdat,true).';';
	$batch_out.= "\n?>";
	
	if('yes' == $reserve_yes)
	{
		// 予約配信へ
		$batch_id = 'reserve_'.$project_cd.'_'.$thread_id.'_'.$startdatetime;
		file_put_contents(HIDDEN_BATCH_DIR.$batch_id.'.php',$batch_out);
		// 0:指定日時, 1:予約した日時,2:prjcd,3:threadid,4:batch_id,5:題名,6:筆者名,7:ブログ名
		$record = $startdatetime."\t".date("YmdHis")."\t".$prjdat['cd']."\t".$thread_id."\t".
			$batch_id."\t".$title."\t".$name."\t".$prjdat['cd']."\n";
		$reserve_filename = SYS_DIR.'reserve_entry.txt';
		add_file($reserve_filename,$record);
		return;
	}else{
		$batch_id = 'now_'.$project_cd.'_'.$thread_id.'_'.$startdatetime;
		file_put_contents(HIDDEN_BATCH_DIR.$batch_id.'.php',$batch_out);
	}

	// 即配信
	$command = APATH_PHP_EXE.' ';
	$command.= APATH_SCRIPT_DIR.'batch.php publog_batch '.$batch_id;
//	$command.= $mail_from.' ';
//	$command.= $mail_list_path.' ';
//	$command.= $mail_body_path.' ';
if(OS_TYPE == OS_TYPE_UNIX)
{
	$command.= '> /dev/null &';
}	
	// エントリープロセスをキック
	$res = system($command);

	return;

















	// html特殊文字の処理
/*	if('x' == $inputformat)
	{
		$comment =& phtmlenc($comment);
	}
*/
	// 要約文の作成
	if(empty($summary))
	{
		$summary=strip_tags(mb_strcut($comment,0,DESCRIPTION_CUT_STRLEN,PUBLOG_INTERNAL_ENCODING)).'...';
	}
	$summary=cut_nrt($summary);
//	$summary = phtmlenc($summary);

	// 形式に合わせた記事本文の加工
	$comment=ereg_replace("[\t]","",$comment);
	if(("o"!=$inputformat)&&("h"!=$inputformat)&&("w"!=$inputformat)){
//		$comment=phtmlenc($comment);
	}
//	if(("h"==$inputformat)||("w"==$inputformat)){
//		$comment=ereg_replace("[\n\r]+",PUBLOG_BETA_BR,$comment);
//	}else{
//		$comment=nl2br($comment);
//		$comment=ereg_replace("[\n\r]","",$comment);
//	}
	// \r\n\t カット
//	$vars=cut_nrt($vars);

	// 処理前の内容を保存
	$comment_moto=$comment;	// メール用に元データを保存
	$title_moto=$title;
	$name_moto=$name;

	// タグ除去など
	$name=strip_tags($name);
//	$title=phtmlenc($title);
	$url=strip_tags($url);
	$email=strip_tags($email);

//	$name = check_name($name,$prj);
// $name は 生トリップキーがついた状態↓
	$name_list=sep_name_trip10($name);	// name, trip
//	$name_list['name'] = phtmlenc($name_list['name']);

	$now = now_w3c();
//	$entry_id = date("YmdHis");
	$entry_id = $startdatetime;
	$systpl->assign('entry_id',$entry_id);
	if($type == 'wiki' or $type == 'html' or $type == 'htrmlbr')
	{
		$format = 'text/html';
	}else{
		$format = 'text/plain';
	}

	$url_this_entry = BlogPageGenerator::gen_entry_filename($thread_id,$entry_id,HTTP_HOME_DIR.$prjdat['cd'].'/archives/blog/');

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $project_cd
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'comment' => array(
					'id' => null
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);
	// エントリーファイルの生成
	$ini_entry = array(
		'entry' => array(
			'id' => $entry_id,
			'uri' => $entry_uri,
			'parent' => array(
				'id' => $thread_id
			),
			'title' => $title,
			'link' => $link,
			'input_format' => $inputformat,
			'type' => 'text',
			'format' => $format,
			'language' => LANG,
			'content' => $comment,
			'summary' => $summary,
			'issued' => $now,
			'modified' => $now,
			'author' => array(
				'name' => $name_list['name'],
				'trip' => $name_list['trip']
			),
			'subject' => null,
			'virtualdirectory' => $virtualdirectory,
			'publisher' => null,
			'rights' => null,
			'image' => array(
				'uri' => $image['uri'],
				'md5' => $image['md5']
			),
			'radio' => array(
				'uri' => $radio['uri'],
				'md5' => $radio['md5']
			),
			'flash' => array(
				'uri' => $flash['uri'],
				'md5' => $flash['md5']
			)
		)
	);
	$entry =& $blogdata->create('entry');
	$entry->new_xml_file($ini_entry);


	// コメントファイルの生成
	$ini_commentlist = array(
		'commentlist' => array(
			'id' => $startdatetime,
			'parent' => array(
				'id' => $startdatetime
			),
			'count' => '0'
		)
	);

	$commentlist =& $blogdata->create('commentlist');
	$commentlist->new_xml_file($ini_commentlist);

	// エントリーリストの生成
	$ini_entrylist = array(
		'id' => $entry_id,
		'title' => $title,
		'summary' => $summary,
		'issued' => $now,
		'modified' => $now,
		'author' => array(
				'name' => $name_list['name'],
				'trip' => $name_list['trip']
			)
	);
	if(!($entrylist =& $blogdata->load('entrylist')))
	{
		die ("EntrylistData Load Error(".$entrylist->conf['xml_file']['full_path'].")");
	}
	$entrylist->add($ini_entrylist);
	$entrylist->_save();


	// スレッドリストファイルの更新とage

	if(!($threadlist =& $blogdata->load('threadlist')))
	{
		die ("ThreadlistData Load Error(".$threadlist->conf['xml_file']['full_path'].")");
	}
	$threadlist->age($thread_id);



	// ページ更新
	blog_thread_all_rebuild($project_cd,$thread_id,$base_id=null,$lang_id=null);
/*
	// ページ更新
	$blogconf = array(
				'base' => array(
					'id' => null		// ex. 'www.example.com/home/'
				),
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $thread_id
				),
				'xml_file' => array(
					'sys_dir' => null,
//					'base_dir' => APATH_HOME_DIR.$project_cd.'/sys/data/'
					'base_dir' => APATH_HOME_DIR
				)
			);

	// テンプレートの場所決め
	if(is_dir(APATH_HOME_DIR.$project_cd.'/design/blog/'.$thread_id.'/current'))
	{
		$template_base_dir =APATH_HOME_DIR.$project_cd.'/design/blog/'.$thread_id.'/current/';
	}elseif(is_dir(APATH_HOME_DIR.$project_cd.'/design/blog/default/current')){
		$template_base_dir =APATH_HOME_DIR.$project_cd.'/design/blog/default/current/';
	}else{
		die("blog template directory not found.");
	}
	$page_conf = array(
		'0' => array(
			'template_base_dir' => $template_base_dir,	// template file
			'to' => 'file',	// file
			'file_base_dir' => APATH_HOME_DIR.$project_cd.'/archives/blog/',
			'filename_prefix' => null,	// 出力ファイルにプレフィックスをつけたい場合
			'out_file_name' => null,		// output file (blog page)
			'out_data' => null // output data (text, page data)
		)
	);
	$blog =& new BlogPageGenerator($blogconf,$page_conf);
	$blog->generate_page_entry();
	print($blog->page_conf[0]['out_data']);	
*/

	$systpl->assign('thread_id',$thread_id);

	$thread =& $blogdata->load('thread');
	if($thread)
	{
		$thread_data =& $thread->get_data();
	}
	$Thread = array(
		'id' => $thread_id,
		'title' => $thread_data['thread']['title']
	);

	// trackback
	$tbdata = array(
		'title'     => $title, // タイトル
		'url'       => $url_this_entry, // 送信時に再度、rawurlencode される
		'excerpt'   => $summary,
		'blog_name' => $Thread['title'],
		'charset'   => PUBLOG_INTERNAL_ENCODING, // 送信側文字コード(未既定)
		'author'   => $name_list['name'], // 執筆者:拡張
		'virtualdirectory'   => $virtualdirectory // バーチャルディレクトリ:拡張
	);
	tb_send($tbdata,$comment);


	$systpl->assign('http_archive_dir',HTTP_HOME_DIR.$project_cd.'/archives/');

        $systpl->assign('http_archive_dir',HTTP_HOME_DIR.$project_cd.'/archives/');

	// メール設定ファイル読み込み(mail.ini)
	$mail_ini_file = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail.ini';
	if(file_exists($mail_ini_file))
	{
		$mail_ini = parse_ini_file($mail_ini_file,true);
	}
	// エントリーメール発射
	if(!empty($mail_ini) and !empty($mail_ini['mail']['from'])){
		// HTML メール
		$mail_body_path_html = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mailbody_'.$thread_id.'_'.$entry_id.'_html.txt';
		$mail_list_path_html = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail_list_html.txt';
		$mail_from = $mail_ini['mail']['from'];
		$mail_subject = '['.$project_cd.'] '.$title;
		if(file_exists($mail_list_path_html))
		{
			entry_mail_set_html($mail_from,$mail_subject,
				$entry_path,$entry_uri,$prjdat['homeurl'],$mail_body_path_html);
			if(file_exists($mail_body_path_html))
			{
				entry_mail_kick($mail_from,$mail_list_path_html,$mail_body_path_html);
			}
		}
		// TEXT メール
		$mail_body_path_text = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mailbody_'.$thread_id.'_'.$entry_id.'_text.txt';
		$mail_list_path_text = HIDDEN_DIR.$project_cd.'/'.$thread_id.'/mail_list_text.txt';
		$mail_from = $mail_ini['mail']['from'];
		$mail_subject = '['.$project_cd.'] '.$title;
		if(file_exists($mail_list_path_text))
		{
			entry_mail_set_text($mail_from,$mail_subject,
				$comment,$entry_uri,$prjdat['homeurl'],$mail_body_path_text);
			if(file_exists($mail_body_path_text))
			{
				entry_mail_kick($mail_from,$mail_list_path_text,$mail_body_path_text);
			}
		}
	}
	$systpl->assign('mailmagazine_kick',$mailmagazine_kick);

	// カテゴリping
	if(TRACKBACK_CATEGORY_NODE_SERVER and !empty($virtualdirectory)){
		// auto-trackback(カテゴリ)
		$cat_data=load_blog_cat_list();	// ブログカテゴリテーブルを読み込む
		$cat_tb_uri=$cat_data[$virtualdirectory][2];
		$result = http_request($cat_tb_uri,'POST','',$tbdata);
	}


return;





/*
	// 画面表示
	prj_login_html_out("投稿完了",$outdata,"<META http-equiv=\"refresh\" content=\"2;URL=prjtool".PUBLOG_PHP_EXTENSION."?action=editbbs_top_view\">",$logindat,"print");
*/

	$trdlist=array();
	$trdlist[]=$thread_id;
	// 1ページ再構築	
	one_bbs_page_rebuild($prj,$thread_id,$bbsdata["newcommentno"],substr($startdatetime,0,8));

	// html メール送出
	if(("info"!=$thread_id)&&("o"==$prjdat["status"])&&($virtualdirectory!="test"))
	{
			$mailfilename=APATH_HOME_DIR.$prj."/archives/".$thread_id.((string)$bbsdata["newcommentno"]).".html";
	mail("2logall-html@freeml.com",gen_subject($prjdat["name"].":".$title_moto),$mailbody,"From: 2chblog-all@dempa2ch.net\nMIME-Version: 1.0\nContent-Type: text/html; charset=ISO-2022-JP");

	}



//---------------------------

	// RSS 出力
	$enc="UTF-8";
	$rssdata=rssout($prj,$thread_id,$enc);
	$filename=APATH_HOME_DIR.$prjdat["cd"]."/".$thread_id.".rdf";
	write_file($filename,$rssdata);

	$name=conv_name($name);	// トリップ変換済みのnameに変換 ↑※これより前nのnameは生トリップキーなので注意※



// MLに投げたり、最新リストに追加したり。
//	if(("blog"==$hakoid)&&("o"==$prjdataset["status"])){
	if(("info"!=$thread_id)&&("o"==$prjdat["status"])){

		// 最新リストに追加
		$filename_post=OPEN_DIR."new_entry1000.txt";
		if(file_exists($filename_post)){
			$wndata=load_file_table($filename_post);
		}
		$filename_prj=OPEN_DIR."new_entry_project.txt";
		if(file_exists($filename_prj)){
			$wndata_prj=load_file_table($filename_prj);
		}
		$out_post="";
		$out_post.=$startdatetime."\t".$title."\t".$name."\t".$prjdat["cd"]."\t".$prjdat["name"]."\t".$prjdat["homeurl"]."\t".$prjdat["cat"]."\n";
		$out_prj="";
		$out_prj.=$out_post;

		// 投稿ごと
		$wn_count=count($wndata);
		for($i=0;($i<$wn_count)&&$i<999;$i++){
			if($wndata[$i][0]=="") continue;
			$out_post.=$wndata[$i][0]."\t";
			$out_post.=$wndata[$i][1]."\t";
			$out_post.=$wndata[$i][2]."\t";
			$out_post.=$wndata[$i][3]."\t";
			$out_post.=$wndata[$i][4]."\t";
			$out_post.=$wndata[$i][5]."\t";
			$out_post.=$wndata[$i][6]."\n";
		}
		write_file($filename_post,$out_post);	// 投稿ごと

		// プロジェクトごと
		$wn_count_prj=count($wndata_prj);
		$ctr_prj=0;
		for($i=0;($i<$wn_count_prj)&&$ctr_prj<999;$i++){
			if($wndata_prj[$i][0]=="") continue;
			if($prjdat["cd"]==$wndata_prj[$i][3]){
				continue;	// 同じコードのものははじく
			}
			$out_prj.=$wndata_prj[$i][0]."\t";
			$out_prj.=$wndata_prj[$i][1]."\t";
			$out_prj.=$wndata_prj[$i][2]."\t";
			$out_prj.=$wndata_prj[$i][3]."\t";
			$out_prj.=$wndata_prj[$i][4]."\t";
			$out_prj.=$wndata_prj[$i][5]."\t";
			$out_prj.=$wndata_prj[$i][6]."\n";
			$ctr_prj++;
		}
		write_file($filename_prj,$out_prj);	// プロジェクトごと


		// 最新エントリーページ更新
		$ent_out=disp_blog_entry_whatsnew(50);
		write_file(OPEN_DIR."new_entry.html",$ent_out);
		// 最新エントリーページ更新(シンプル)
		$ent_out=disp_blog_entry_whatsnew_simple(20);
		write_file(OPEN_DIR."new_entry_simple.html",$ent_out);
		// 最新エントリーページ(カテゴリごと)更新
		$ent_out=disp_blog_entry_whatsnew_cat(5);
		write_file(OPEN_DIR."new_entry_cat.html",$ent_out);
	}


	// トラックバックping発射
	if($tburl!=""){
		send_tb_ping($tburl,$title_moto,$newcommenturl,$excerpt,$prjdat["name"],$name);
	}


	if("info"!=$thread_id){
		if("test"!=$topic){
			// Myblog
			if(TRACKBACK_MYBLOG){
				send_tb_ping("http://ping.myblog.jp/",$title_moto,$newcommenturl,$excerpt,$prjdat["name"],$name);
			}
		}
		
		if(TRACKBACK_CATEGORY_NODE_SERVER){
		// auto-trackback(カテゴリ)
		$cat_data=load_blog_cat_list();	// ブログカテゴリテーブルを読み込む
		$cat_tb_uri=$cat_data[$topic][2];
		send_tb_ping($cat_tb_uri,$title_moto,$newcommenturl,$excerpt,$prjdat["name"],$name);
		}
	}

}
?>
