<?php
// $Id: rm_entry.done.php,v 1.1 2004/08/06 08:25:08 fukami Exp $
// エントリー削除

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	extract($vars);
	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $prjdat['cd']
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'comment' => array(
					'id' => null
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);

	$cat_data =& load_blog_cat_list();
	$VirtualDirectory = array();
	foreach($cat_data as $key => $val)
	{
		$VirtualDirectory[$key]=$val[1];
	}
	$systpl->assign_by_ref('VirtualDirectory',$VirtualDirectory);
	
	// Core
	$Core = array(
		'id' => LANG
	);
	$systpl->assign_by_ref('Core',$Core);

	// Base
	$Base = array(
		'cd' => PUBLOG_SERVER_NAME
	);
	$systpl->assign_by_ref('Base',$Base);
	// Project
	$Project = array(
		'cd' => $prjdat['cd'],
		'title' => $prjdat['name']
	);
	$systpl->passign_by_ref('Project',$Project);

	// Thread
	$thread =& $blogdata->load('thread');
	if($thread)
	{
		$thread_data =& $thread->get();
	}else{
		die("Thread data load error");
	}
	$systpl->passign_by_ref('Thread',$thread_data);

	// Entry
	$entry =& $blogdata->load('entry');
	if($entry)
	{
		$entry_data =& $entry->get();
	}else{
		die("Thread data load error");
	}
	$systpl->passign_by_ref('Entry',$entry_data);
	// media_type
	$systpl->passign_by_ref('media_type',$media_type);

	// ----- データ削除

	// Entrylist
	$entrylist =& $blogdata->create('entrylist');
	if($entrylist->load())
	{
		$entrylist_data =& $entrylist->get();
	}else{
		die("entrylist load error.");
	}
//print_r($entrylist_data);
	$entrylist_data['entrylist']['entry__'.$entry_id] = null;
	unset($entrylist_data['entrylist']['entry__'.$entry_id]);
//print_r($entrylist_data);
	$entrylist->_save();


	// data ディレクトリ
	$rm_data_dir = APATH_HOME_DIR.$prjdat['cd'].'/data/blog/'.$thread_id.'/'.
			substr($entry_id,0,4).'/'.
			substr($entry_id,4,2).'/';
	$rm_data_file = '.*'.substr($entry_id,6,2).'_'.
			substr($entry_id,-6).'.+';
	if(is_writeable($rm_data_dir))
	{
		rm_ereg_files($rm_data_dir,$rm_data_file);
	}
	// archives ディレクトリ
	$rm_archives_dir = APATH_HOME_DIR.$prjdat['cd'].'/archives/blog/'.$thread_id.'/'.
			substr($entry_id,0,4).'/'.
			substr($entry_id,4,2).'/';
	$rm_archives_file = '.*'.substr($entry_id,6,2).'_'.
			substr($entry_id,-6).'.+';
	if(is_writeable($rm_archives_dir))
	{
		rm_ereg_files($rm_archives_dir,$rm_archives_file);
	}
	
	// media ディレクトリ
	$rm_media_dir = APATH_HOME_DIR.$prjdat['cd'].'/media/blog/'.$thread_id.'/'.
			substr($entry_id,0,4).'/'.
			substr($entry_id,4,2).'/';
	$rm_media_file = '.*'.substr($entry_id,6,2).'_'.
			substr($entry_id,-6).'.+';
	if(is_writeable($rm_media_dir))
	{
		rm_ereg_files($rm_media_dir,$rm_media_file);
	}
	
	return;
}
?>
