<?php
/********************************************************************
 *
 *  PUBLOGトラックバックモジュール
 *  lv=base,mod=tb
 *  $Id: tb.done.php,v 1.3 2004/09/21 16:59:07 fukami Exp $
 *
 * Publog Developers Team  http://publog.net/
 * License: GPL
 ********************************************************************/

require_once('class/xml.class.php');
require_once('class/publogxmldata.class.php');
require_once('class/publogxmllistdata.class.php');
require_once('class/projectdata.class.php');
require_once('class/threadlistdata.class.php');
require_once('class/threaddata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrylistdata.class.php');
require_once('mod/thread/blog/class/entrydata.class.php');
require_once('mod/thread/blog/class/commentlistdata.class.php');
require_once('mod/thread/blog/class/blog_pagegenerator.class.php');
require_once('mod/thread/blog/class/blog_smarty.class.php');

require_once('class/publogdata.class.php');
require_once('mod/thread/blog/class/blog_data.class.php');

require_once('mod/thread/blog/blog.func.php');

require_once('func/trackback.func.php');

function do_mod_proc_disp()
{
	global $vars, $retvars;
	global $smes,$pmes;
	global $logindat,$prjdat,$userdat;
	global $systpl;
	require('func/inc/vars_to_variable.inc.php');

	// TrackBack Ping における URL パラメータは必須である。
	if (empty($url))
	{
		tb_xml_msg(1,'It is an indispensable parameter. URL is not set up.');
	}
	// Query String を得る
	if (empty($id))
	{
		tb_xml_msg(1,'TrackBack Ping URL is inaccurate.');
	}

	$id_arr = explode('/',$id);
	if(3 > count($id_arr))
	{
		tb_xml_msg(1,'TrackBack id Error.');
	}
	$project_cd = $id_arr[0];
	$thread_id = $id_arr[1];
	$entry_id = $id_arr[2];

	if(empty($author))
	{
		$author = '名無しさん';
	}
	
	

	$entry_id_yyyy = substr($entry_id,0,4);
	$entry_id_mm = substr($entry_id,4,2);

	$name_list=sep_name_trip10($author);	// name, trip
	$now = now_w3c();

	// データオブジェクト ====================
	$blogdata_conf = array(
				'project' => array(
					'cd' => $project_cd
				),
				'thread' => array(
					'id' => $thread_id
				),
				'entry' => array(
					'id' => $entry_id
				),
				'xml_file' => array(
					'sys_dir' => SYS_DIR,
					'base_dir' => APATH_HOME_DIR,
					'script_dir' => APATH_SCRIPT_DIR
				)
			);
	$blogdata = new BlogData($blogdata_conf);
/*
	$conf_commentlist = array(
		'xml_file' => array(
			'full_path' =>  APATH_HOME_DIR.$project_cd.'/sys/data/thread/'.$thread_id.'/'.$entry_id_yyyy.'/'.$entry_id_mm.'/commentlist_'.$entry_id.'.xml'
		)
	);
*/
	$add_comment = array(
//			'comment' => array(
				'id' => null,
				'title' => $title,
				'link' => $url,
				'type' => 'text',
				'format' => 'text/plain',
				'language' => LANG,
				'author' => array(
					'name' => $name_list['name'],
					'trip' => $name_list['trip'],
					'email' => null
				),
				'content' => $excerpt,
				'issued' => $now,
				'modified' => $now,
				'publisher' => $blog_name
//			)
	);


	$commentlist =& $blogdata->load('commentlist');
	$commentlist->add($add_comment);
	$commentlist->_save();

	// Entry
	$entry =& $blogdata->load('entry');
	if($entry)
	{
		$entry_data =& $entry->get();
	}else{
		die("Entry data load error");
	}
	$systpl->assign_by_ref('Entry',$entry_data);

	recently_writeback_add($project_cd,$thread_id,null,$url,null,$title,$name_list,$now,$entry_data);

	// ページ更新
	blog_thread_all_rebuild($project_cd,$thread_id,PUBLOG_SERVER_NAME,LANG);

	tb_xml_msg(0,'');
	die;
}
?>
